#include "uwbgl_D3DPointLight1.h"
#include "uwbgl_D3DPrimitiveMesh3.h"
#include "uwbgl_SceneNode7.h"

UWBD3D_PointLight::UWBD3D_PointLight(int id) : UWBD3D_Light(id)
{
  SetToPointLight();
}

UWBD3D_PointLight::~UWBD3D_PointLight()
{
}

void UWBD3D_PointLight::DrawLightGeometry(UWB_DrawHelper& draw_helper)
{
  UWB_SceneNode node;
  UWB_XformInfo xf = node.GetXformInfo();
  vec3 p;
  GetPosition(p);
  xf.SetTranslation( p);
  xf.SetScale( vec3(0.3f, 0.3f, 0.3f) );
  node.SetXformInfo( xf );
    
  UWB_Color c = GetDiffuse();
  UWBD3D_PrimitiveMesh *m = new UWBD3D_PrimitiveMesh(L"sphere.x");
  m->EnableLighting(false);
  m->SetShadeMode(smFlat);
  m->SetFlatColor(c);
  
  node.SetPrimitive( m );
  node.Draw(draw_helper.GetLOD(), draw_helper);
}