#include "uwbgl_D3DPrimitiveMeshAxis4.h"
#include "uwbgl_D3DGraphicsSystem7.h"
#include "uwbgl_XformInfo6.h"


UWBD3D_PrimitiveMeshAxis::UWBD3D_PrimitiveMeshAxis(float s)
: m_Scale(s)
{
  m_xaxis.SetFlatColor( UWB_Color(255,0,0) );
  m_yaxis.SetFlatColor( UWB_Color(0,255,0) );
  m_zaxis.SetFlatColor( UWB_Color(0,0,255) );
}

void UWBD3D_PrimitiveMeshAxis::DrawPrimitive( eLevelOfDetail lod, UWB_DrawHelper& draw_helper )
{
  UWB_XformInfo xf;
  xf.SetScale(m_Scale);
  draw_helper.PushModelTransform();
    xf.SetUpModelStack(draw_helper);
  m_xaxis.Draw( lod, draw_helper );
  draw_helper.PopModelTransform();

  UWB_XformInfo yrot;
  yrot.UpdateRotationZByDegree(90.0f);
  yrot.SetScale(m_Scale);
  draw_helper.PushModelTransform();
    yrot.SetUpModelStack( draw_helper );
    m_yaxis.Draw( lod, draw_helper );
  draw_helper.PopModelTransform();

  UWB_XformInfo zrot;
  zrot.UpdateRotationYByDegree(-90.0f);
  zrot.SetScale(m_Scale);
  draw_helper.PushModelTransform();
    zrot.SetUpModelStack( draw_helper );
    m_zaxis.Draw( lod, draw_helper );
  draw_helper.PopModelTransform();
}