// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_Common.h"

#define SetMaterialProperty(materialType) 		\
	void Set##materialType##(float v)	{					\
    UWB_Color c(v, v, v, v);                  \
    m_##materialType = c;										      \
	}																	          \
	void Set##materialType##(float r, float g, float b, float a=1.0) {	\
    UWB_Color c(r, g, b, a);                  \
		m_##materialType = c;										      \
	}																	          \
	void Set##materialType##(const UWB_Color &v) {		\
		m_##materialType = v;									          \
	}																	                \
	void Get##materialType##(UWB_Color &v) const {		\
    v = m_##materialType;									          \
	}																	                \
  float Get##materialType##R() const { return m_##materialType.PercentRed();}	\
	float Get##materialType##G() const { return m_##materialType.PercentGreen();}	\
	float Get##materialType##B() const { return m_##materialType.PercentBlue();}	\
	float Get##materialType##A() const { return m_##materialType.PercentAlpha();}


//
// material property for: We wrap around
//
class UWB_Material {
	//
	private:
    UWB_Color m_Diffuse;
    UWB_Color m_Ambient;
    UWB_Color m_Specular;
    UWB_Color m_Emissive;
    float     m_Power;
		
	public:
		UWB_Material() {
			//
			//
			// nice shade of Husky purple ...
			//
			SetAmbient(0.13f, 0.065f, 0.195f, 1.0f);
			//
			//
			// grey-ish  dull color otherwise ...
			// //
			SetEmissive(0.1f);
			SetDiffuse(0.8f);
			SetSpecular(0.2f);
			SetPower(1.0f);
		}

		//
		// define the setting and accessing functions
		//
		SetMaterialProperty(Emissive)
		SetMaterialProperty(Ambient)
		SetMaterialProperty(Diffuse)
		SetMaterialProperty(Specular)

		void  SetPower(float s) { m_Power = s; }
		float GetPower() { return m_Power; }
};